/////////////////////////////////////////////////
// cdrom.cpp - CDROM Music for Monkey Island 1 //
/////////////////////////////////////////////////

//By: realmz

//Last Modified: Nov 10, 2001

#include "cdrom.h"

#include </usr/local/include/SDL/SDL.h>

#include "stdafx.h"

#define nSounds 15

SDL_CD *cdrom;
CDstatus status;
char *status_str;

int cdstatus;

//Status >> 0 or -1 = Disabled
//Status >> 1 = Ready
//Status >> 2 = Stopped
//Status >> 3 = Playing

int current_sound;

int current_soundelement;

int track_sound[nSounds];
int cdtrack[nSounds];
int sound_start[nSounds];



//Unsupport Sound effects (NOT MUSIC):
//98 - Fire
//31 - Bell
//Lots of others

void
CD_Init ()
{
  cdstatus = 0;
  current_sound = (-2);
  current_sound = (-3);
  /* Initialize SDL first */
  if (SDL_Init (SDL_INIT_CDROM) < 0)
    {
      fprintf (stderr, "Couldn't initialize SDL: %s\n", SDL_GetError ());
	CD_Disable();
	return;
    }

  cdrom = SDL_CDOpen (0);
  if (cdrom == NULL)
    {
      fprintf (stderr, "Couldn't open default CD-ROM drive: %s\n",
	       SDL_GetError ());
	CD_Disable();
	return;
    }

  cdstatus = 1;

  track_sound[0] = 110;		//Intro
  track_sound[1] = 108;		//Intro-Lookout
  track_sound[2] = 100;		//Meanwhile... <LeChuck>
  track_sound[3] = 101;		//SCUMM Bar
  track_sound[4] = 122;		//Dock Sounds
  track_sound[5] = 112;		//Melee Island Map
  track_sound[6] = 109;		//Forest.
  track_sound[7] = 115;		//Voodoo
  track_sound[8] = 103;		//Chapel
  track_sound[9] = 114;		//Jail
  track_sound[10] = 126;	//Night sounds
  track_sound[11] = 121;	//Stan's Used Ships
  track_sound[12] = 113;	//Circus
  track_sound[13] = 117;	//Guybrush & Elaine (118)
  track_sound[14] = 104;	//Part x (108)

  cdtrack[0] = 17;
  cdtrack[1] = 17;
  cdtrack[2] = 10;
  cdtrack[3] = 8;
  cdtrack[4] = 22;
  cdtrack[5] = 5;
  cdtrack[6] = 3;
  cdtrack[7] = 1;
  cdtrack[8] = 4;
  cdtrack[9] = 2;
  cdtrack[10] = 23;
  cdtrack[11] = 18;
  cdtrack[12] = 11;
  cdtrack[13] = 7;
  cdtrack[14] = 6;

  //Where in the track to start, Mainly used in the intro
  sound_start[0] = 0;
  sound_start[1] = 96;
  sound_start[2] = 0;
  sound_start[3] = 0;
  sound_start[4] = 120;
  sound_start[5] = 0;
  sound_start[6] = 0;
  sound_start[7] = 0;
  sound_start[8] = 0;
  sound_start[9] = 0;
  sound_start[10] = 0;
  sound_start[11] = 0;
  sound_start[12] = 0;
  sound_start[13] = 0;
  sound_start[14] = 0;

}

void
CD_PlayTrack (int track, int start, int end)
{
  CD_Stop (); //Stop the music first

  SDL_CDStatus (cdrom); //Update SDL_CD

//Removed support for specifying the end because it's not needed
//(Most music plays till end of track or is stopped by the script)

  SDL_CDPlayTracks (cdrom, track, start * CD_FPS, 0, 0);



  cdstatus = 3; //Set status to playing

}

void
CD_Stop ()
{

if(cdstatus < 1) //CD Disabled
return;

  SDL_CDStop (cdrom);
//current_sound=-1; //Old status
  cdstatus = 2;
}

void
play_CD_Sound (int sound)
{

if(cdstatus < 1) //CD Disabled
return;

  if (sound == current_sound) //Don't restart if we leave a conversation
    {

      return;
    }

    printf("Debug >> Sound # %d\n",sound); //Only used to make a list of sounds 

  //Go through list, may possibly cause a TINY pause
  for (int i = 0; i < nSounds - 1; i++)
    {

      if (track_sound[i] == sound)
	{
	  current_sound = sound;
	  CD_PlayTrack (cdtrack[i], sound_start[i], 0);
	  current_soundelement = i; //Set the element in the array
	  return;
	}
    }
current_sound=-1;
}

//Allows the status to be obtained from other cpp files
int CD_GetStatus()
{
return cdstatus;
}

//Check to see if the music needs to be looped
void CD_MusicLoop()
{

if(cdstatus < 1) //CD Disabled
return;

SDL_CDStatus(cdrom); //Update SDL_CD


if(cdrom->cur_track != cdtrack[current_soundelement] && cdstatus == 3)
{
CD_Stop();
CD_PlayTrack(cdtrack[current_soundelement],sound_start[current_soundelement],0);
}

}

//Sets the status to disabled
void CD_Disable()
{
cdstatus = -1;
}

